package payment.api4cb.tx.cbfc;

import java.util.Iterator;
import java.util.List;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import payment.api4cb.tx.TxBaseRequest;
import payment.api4cb.vo.CbfcProduct;

public class Tx5651Request extends TxBaseRequest {

   private String institutionID;
   private String serialNumber;
   private String orderNo;
   private String orderDate;
   private String currency;
   private String cardType;
   private String amount;
   private String settlementFlag;
   private String domain;
   private String pageURL;
   private List itemList;


   public void process() throws Exception {
      DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
      DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
      Document document = documentBuilder.newDocument();
      Element Request = document.createElement("Request");
      Element Head = document.createElement("Head");
      Element Body = document.createElement("Body");
      Element TxCode = document.createElement("TxCode");
      Element InstitutionID = document.createElement("InstitutionID");
      Element SerialNumber = document.createElement("SerialNumber");
      Element OrderNo = document.createElement("OrderNo");
      Element OrderDate = document.createElement("OrderDate");
      Element Currency = document.createElement("Currency");
      Element Amount = document.createElement("Amount");
      Element SettlementFlag = document.createElement("SettlementFlag");
      Element Domain = document.createElement("Domain");
      Element PageURL = document.createElement("PageURL");
      Request.setAttribute("version", "2.1");
      document.appendChild(Request);
      Request.appendChild(Head);
      Head.appendChild(InstitutionID);
      Head.appendChild(TxCode);
      Request.appendChild(Body);
      Body.appendChild(SerialNumber);
      Body.appendChild(OrderNo);
      Body.appendChild(OrderDate);
      Body.appendChild(Currency);
      Body.appendChild(Amount);
      Body.appendChild(SettlementFlag);
      Body.appendChild(Domain);
      Body.appendChild(PageURL);
      TxCode.setTextContent(this.txCode);
      InstitutionID.setTextContent(this.institutionID);
      SerialNumber.setTextContent(this.serialNumber);
      OrderNo.setTextContent(this.orderNo);
      OrderDate.setTextContent(this.orderDate);
      Currency.setTextContent(this.currency);
      Amount.setTextContent(this.amount);
      SettlementFlag.setTextContent(this.settlementFlag);
      Domain.setTextContent(this.domain);
      PageURL.setTextContent(this.pageURL);
      Iterator var18 = this.itemList.iterator();

      while(var18.hasNext()) {
         CbfcProduct item = (CbfcProduct)var18.next();
         Element Item = document.createElement("Item");
         Element product = document.createElement("Product");
         Element price = document.createElement("Price");
         Element count = document.createElement("Count");
         Item.appendChild(product);
         Item.appendChild(price);
         Item.appendChild(count);
         product.setTextContent(item.getProduct());
         price.setTextContent(String.valueOf(item.getPrice()));
         count.setTextContent(String.valueOf(item.getCount()));
         Body.appendChild(Item);
      }

      this.postProcess(document, this.institutionID);
   }

   public String getInstitutionID() {
      return this.institutionID;
   }

   public void setInstitutionID(String institutionID) {
      this.institutionID = institutionID;
   }

   public String getSerialNumber() {
      return this.serialNumber;
   }

   public String getSettlementFlag() {
      return this.settlementFlag;
   }

   public void setSettlementFlag(String settlementFlag) {
      this.settlementFlag = settlementFlag;
   }

   public void setSerialNumber(String serialNumber) {
      this.serialNumber = serialNumber;
   }

   public String getOrderNo() {
      return this.orderNo;
   }

   public void setOrderNo(String orderNo) {
      this.orderNo = orderNo;
   }

   public String getOrderDate() {
      return this.orderDate;
   }

   public void setOrderDate(String orderDate) {
      this.orderDate = orderDate;
   }

   public String getCurrency() {
      return this.currency;
   }

   public void setCurrency(String currency) {
      this.currency = currency;
   }

   public String getCardType() {
      return this.cardType;
   }

   public void setCardType(String cardType) {
      this.cardType = cardType;
   }

   public String getAmount() {
      return this.amount;
   }

   public void setAmount(String amount) {
      this.amount = amount;
   }

   public String getPageURL() {
      return this.pageURL;
   }

   public void setPageURL(String pageURL) {
      this.pageURL = pageURL;
   }

   public List getItemList() {
      return this.itemList;
   }

   public void setItemList(List itemList) {
      this.itemList = itemList;
   }

   public String getDomain() {
      return this.domain;
   }

   public void setDomain(String domain) {
      this.domain = domain;
   }
}
